/*
   RUPLIST - written by Roalt Zijlstra - Copyright 1996
   
   See for version number the Makefile.
   
   THIS SOFTWARE IS -AS IS-. USE OF THIS SOFTWARE IS AT YOUR OWN RISK
   THE AUTHOR IS NOT RESPONSIBLE FOR ANY HARM DONE TO YOUR COMPUTER BY USING
   THIS SOFTWARE.

   Ruplist may be distributed freely as long as no profit is made on 
   distribution.
   
*/

/* ==================== Database Stuff here ==================== */


int init_pwd_db(lup_ent **db){
 
  (*db)=malloc(sizeof(lup_ent));
  if(!(*db)) {
    printf("Ruplist: Out of memory. Exiting now.\n");
    exit(0);
  }
    
  (*db)->name=NULL;
  (*db)->prev=(*db); /* Pointing to itself as end of the list */
  (*db)->next=NULL;
  (*db)->ranking=0;
  (*db)->days=0;
  (*db)->hours=0;
  (*db)->minutes=0;
  (*db)->tbit=0;
  
  return 1;
  
}

int add_lup_ent(lup_ent **db, char *line) {
/* In  : string with userinfo from passwd file
   Out : Non-Zero if the string was parsed correctly
*/
  char name[256], days[256], hours[256], minutes[256];
  lup_ent *next_struct;
  int i;


  if(!(*db)) {
    init_pwd_db(db);
    if(!(*db))
      return 0;
  } else {
    if(!(*db))
      return 0;
    next_struct=(*db)->next;
    (*db)->next=malloc(sizeof(lup_ent)); 
    if((*db)->next==NULL) {
      printf("Ruplist: Out of memory. Exiting now.\n");
      exit(0);
    }
    (*db)->next->name=(*db)->name;
    (*db)->next->prev=(*db);
    (*db)->next->next=next_struct;
    /* Change the third entry its previous element */ 
    if((*db)->next->next) { 
      (*db)->next->next->prev=(*db)->next;
    }
    (*db)->next->ranking=(*db)->ranking;
    (*db)->next->days=(*db)->days;
    (*db)->next->hours=(*db)->hours;
    (*db)->next->minutes=(*db)->minutes;
    (*db)->next->tbit=0;
  
    (*db)->name=NULL;
    /* Only when the second entry is created the prev of the first entry has
       to be changed */
    if((*db)->prev==(*db))
      (*db)->prev=(*db)->next;
    (*db)->ranking=0;
    (*db)->days=0;
    (*db)->hours=0;
    (*db)->minutes=0;
  
  }  
  for (i = 0; i < 256; i++) {
    name[i] = '\0';
    days[i] = '\0';
    hours[i] = '\0';
    minutes[i] = '\0';
  }
  sscanf(line,"%255s%255s%255s%255s",name, days, hours, minutes);
  (*db)->days=atoi(days);
  (*db)->hours=atoi(hours);
  (*db)->minutes=atoi(minutes);

  (*db)->name=malloc((strlen(name)+1) * sizeof(char));
  if((*db)->name==NULL) {
      printf("Ruplist: Out of memory. Exiting now.\n");
      exit(0);
    }
  strcpy((*db)->name,name);
  
  return 1;
}

void clean_lup_ent(lup_ent **db) {

  lup_ent *tmp,*tmp2;

  if(!db) {
    printf("Ruplist debug: Lup entry database pointer empty.\n");
    return;  
  }
  tmp=(*db);
  
 while(tmp->next) {
    tmp2=tmp->next;    
    if(tmp->name) free(tmp->name);
    free(tmp);
    tmp=tmp2;
  }

}


void add_ranking_lup_ent(lup_ent **db) {
  lup_ent *tmp,*tmp2,*print;
  int rank,day,hour,minute,tbit;
  char site[20];
  
  if(sort_type==0) {
    tmp=(*db);
    tmp2=(*db);  
    print=NULL;
    strcpy(site," ");
    tbit=tmp->tbit;    /* set the toggle bit */
    rank=1;
    while(tmp2!=NULL) {
      day=0; hour=0; minute=0;
      while(tmp!=NULL) {
        if(tmp->tbit==tbit) {
          if(tmp->days>day) {
            print=tmp;
            day=tmp->days;
            hour=tmp->hours;
            minute=tmp->minutes;
          }
          if(tmp->days==day) {
            if(tmp->hours>hour) {
              print=tmp;
              day=tmp->days;
              hour=tmp->hours;
              minute=tmp->minutes;
            }
            if(tmp->hours==hour) {
              if(tmp->minutes>=minute) {
                print=tmp;
                day=tmp->days;
                hour=tmp->hours;
                minute=tmp->minutes;
              }
            }
          }
        }
        tmp=tmp->next;
      }
      if(print!=NULL) {
        print->ranking=rank; /* Set ranking */
        if(print->tbit==0)
          print->tbit=1;
        else
          print->tbit=0;
        rank++;
      }
      tmp2=tmp2->next;
      tmp=(*db);
    }
  }      
}

int find_ranking_lup_ent(lup_ent *db, char *sitename) {
  lup_ent *tmp;
  
  tmp=db;
  while(tmp!=NULL) {
    if(strcmp(tmp->name,sitename)==0) 
      return tmp->ranking;
    tmp=tmp->next;
  }
  return 0;    
}



void save_lup_ent(lup_ent *db, const char *filename) {

  lup_ent *tmp;
  FILE *fp;

/* First unlink the file, which means that a sym-link is removed too, so hacking
   it like that is not possible 
*/
  unlink(filename);  
  fp=fopen(filename,"w");
  if(!fp) {
    printf("Ruplist: Cannot open longest uptimes file. Out of harddisc space?\n");
    return;
  }
  
  tmp=db->prev;
  while(tmp!=db) {
    fprintf(fp,"%s %d %d %d\n",tmp->name,tmp->days, tmp->hours,tmp->minutes);
    tmp=tmp->prev;
  }
  if(db->prev!=db) {
    fprintf(fp,"%s %d %d %d\n",tmp->name,tmp->days, tmp->hours,tmp->minutes);
  }

  if(fp) fclose(fp);
  chmod(filename, 0666);
}
  

int load_lup_ent(lup_ent **db, const char *filename) {
  char input[1024];
  FILE *fp;

  fp=fopen(filename,"r");
  if(fp) {
  
    while(!feof(fp)) {
      fgets(input,1024,fp);
      if(feof(fp))
        break;
      if(!add_lup_ent(db,input)) {
         printf("Parse error: Out of memory to allocate passwd enties.\n");
         return 0;
      }
    }
    if(fp) fclose(fp);
  }
                             
  return 1;
}

void show_lup_ent(lup_ent *db) {
  lup_ent *tmp,*tmp2,*print;
  int x,rank,day,hour,minute,tbit;
  char site[20];
  lup_ent *yes_db,*week_db,*month_db;

  if(db==NULL) {
    printf("Ruptime: No hosts ?!?  Is the rwho daemon running?\n");
    return;
  }
 
  yes_db=NULL;
  week_db=NULL;
  month_db=NULL;

  load_lup_ent(&yes_db,luplisty);
  load_lup_ent(&week_db,luplistw);
  load_lup_ent(&month_db,luplistm);
  
  add_ranking_lup_ent(&yes_db);
  add_ranking_lup_ent(&week_db);
  add_ranking_lup_ent(&month_db);


/* 
   This code is completly new because of the sorting stuff in it.
   sorting algorithm: 0 - on uptime (default)
                      1 - on sitename (Not yet implemented)
*/                       
  if(sort_type==0) {
    tmp=db;
    tmp2=db;  
    print=NULL;
    strcpy(site," ");
    tbit=tmp->tbit;    /* set the toggle bit */
    rank=1;
    while(tmp2!=NULL) {
      day=0; hour=0; minute=0;
      while(tmp!=NULL) {
        if(tmp->tbit==tbit) {
          if(tmp->days>day) {
            print=tmp;
            day=tmp->days;
            hour=tmp->hours;
            minute=tmp->minutes;
          }
          if(tmp->days==day) {
            if(tmp->hours>hour) {
              print=tmp;
              day=tmp->days;
              hour=tmp->hours;
              minute=tmp->minutes;
            }
            if(tmp->hours==hour) {
              if(tmp->minutes>=minute) {
                print=tmp;
                day=tmp->days;
                hour=tmp->hours;
                minute=tmp->minutes;
              }
            }
          }
        }
        tmp=tmp->next;
      }
      if(print!=NULL) {
        switch(show_mode) {
          case 0 :
            printf("%2d ",rank);
            x=find_ranking_lup_ent(yes_db,print->name);
            if(x==0) 
              printf("-- ");
            else {
              if(rank==x)
                printf("<- ");
              if(rank>x)
                printf("\\/ ");
              if(rank<x)
                printf("/\\ ");
            }
            printf("%s",print->name);
            break;
          case 1 :
            printf("%2d ",rank);
            if((x=find_ranking_lup_ent(yes_db,print->name))!=0)
              printf("%2d ",x);
            else
              printf("-- ");

            if((x=find_ranking_lup_ent(week_db,print->name))!=0)
              printf("%2d ",x);
            else
              printf("-- ");

            if((x=find_ranking_lup_ent(month_db,print->name))!=0)
              printf("%2d ",x);
            else
              printf("-- ");
              
            printf("- %s",print->name);
            break;
        }         
        x=strlen(print->name);
        x=20-x;
        while(x-->0) {
          printf(" ");
        }
        if(print->days==1) 
          printf(" 1  day, ");
        else
          if(print->days==0)
            printf("         ");
          else 
            printf("%2d days, ",print->days);
      
        if(print->hours==1)
          printf(" 1 hour  ");
        else
          printf("%2d hours ",print->hours);
      
        if(print->minutes==1)
          printf("and  1 minute\n");
        else
          printf("and %2d minutes\n",print->minutes);
        if(print->tbit==0)
          print->tbit=1;
        else
          print->tbit=0;
        rank++;
      }
      tmp2=tmp2->next;
      tmp=db;
    }
  }      
}



/* ==================== Database Stuff ends here ======================== */
