 /*
   RUPLIST - written by Roalt Zijlstra - Copyright 1996
   
   See for version number the Makefile.
   
   THIS SOFTWARE IS -AS IS-. USE OF THIS SOFTWARE IS AT YOUR OWN RISK
   THE AUTHOR IS NOT RESPONSIBLE FOR ANY HARM DONE TO YOUR COMPUTER BY USING
   THIS SOFTWARE.

   Ruplist may be distributed freely. Send any improvements or bug fixes 
   to Roalt Zijlstra <roalt@cal006033.student.utwente.nl>
   
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <syscall.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <dirent.h>
#include <errno.h>

#include "config.h"

struct luptime_entries {
  char *name;
  int ranking;
  int days;
  int hours;
  int minutes;
  int tbit;
  struct luptime_entries *prev;
  struct luptime_entries *next;
} ;


typedef struct luptime_entries lup_ent;

int sort_type,sil_mode,show_mode;
char longest[256],luplisty[256],luplistw[256],luplistm[256],stamps[256],*custom_home;

#include "database.c"

char *convert_time(char *intime) {

  int x;
  char *tmp,*timestr,rest[40],days[20],hours[20],minutes[20];
 
  strcpy(days,"0");
  strcpy(hours,"0");
  strcpy(minutes,"0");
  
  strncpy(rest,intime,39);

/* getting days (if there) */
  tmp=strpbrk(intime,"+");
  if(tmp) {
    x=strlen(intime) - strlen(tmp);
    if(x>=20)
      x=19;
    strncpy(days,intime, x);
    days[x]='\0';
    tmp++;
    strncpy(rest,tmp,39);
  }
               
/* getting passwd */
  tmp=strpbrk(rest,":");
  x=strlen(rest) - strlen(tmp);
  if(x>=39)
    x=39;
  strncpy(hours, rest , x);
  hours[x]='\0';
  tmp++;
  strncpy(rest,tmp,39);

  strncpy(minutes,rest,19);
  
  timestr=malloc((3+strlen(days)+strlen(hours)+strlen(minutes))*sizeof(char));
  if(timestr==NULL) {
      printf("Ruplist: Out of memory. Exiting now.\n");
      exit(0);
  }
  
  sprintf(timestr,"%s %s %s",days,hours,minutes);

  return timestr;                                              
}

int ratoi(char *num) {
  if(strcmp(num,"??")==0)
    return 0;
  return atoi(num);
}


void update_longest_uptime(lup_ent **db, char *name, char *ruptime) {
 
  int found;
  lup_ent *tmp;
  char first[256],second[256],third[256],*convtime;
  int i;

  
 
/* first thing. Does the database exist? If not just make this entry */
  if((*db)==NULL) {
    strncpy(first,name,255);
    strncat(first," ",255-strlen(first));
    convtime=convert_time(ruptime);
    if(convtime) {
      strncat(first,convtime, 255-strlen(first));
      free(convtime);
    }
    add_lup_ent(db,first);
    return;
  } 
 
/* check if the entry exists already */  
  found=0;
  tmp=(*db);
  while(tmp) {
    if(strcmp(tmp->name,name)==0) { /* yeah it's there now compare times */
      found=1;
      convtime=convert_time(ruptime);
      for (i = 0; i < 256; i++) {
         first[i] = second[i] = third[i] = '\0';
      }
      sscanf(convtime,"%255s%255s%255s",first,second,third);
      if(convtime)
        free(convtime);
      if(tmp->days<ratoi(first)) {
        found=2;     /* update!  */
      } else {
        if(tmp->days==ratoi(first) && tmp->hours<ratoi(second)) {
          found=2;
        } else {
          if(tmp->days==ratoi(first) && tmp->hours==ratoi(second) && tmp->minutes<ratoi(third)) {
            found=2;
          }
        }
      }
      if(found==2) { /* updateing time */
        tmp->days=ratoi(first);
        tmp->hours=ratoi(second);
        tmp->minutes=ratoi(third);
      }
      break;
    }
    tmp=tmp->next;
    
  }
  if(found==0) { /* add it cos it was not found in the database */
    strncpy(first,name,255); 
    strncat(first," ",255-strlen(first));
    convtime=convert_time(ruptime);
    strncat(first,convtime,255-strlen(first));
    if(convtime)
      free(convtime);
    add_lup_ent(db,first);
  }    
}

void longest_uptimes(lup_ent **db) {

  int y;
  char date[40],filename[256];
  FILE *fp;
  time_t tijd;  
  
  tijd=time((time_t *)0);
  strncpy(filename,RUPLDIR,230);
  strcat(filename,"ruplist/date");
  fp=fopen(filename,"r");
  if(!fp) {
    printf("Creating first longest uptimes file. ");
    printf("Date stamping on: %s\n",ctime(&tijd));
    fp=fopen(filename,"w");
    fputs(ctime(&tijd),fp); /* We need three times a time at start */
    fputs(ctime(&tijd),fp);
    fputs(ctime(&tijd),fp);
    fclose(fp);
    chmod(filename, 0644);

    sil_mode=2;
    return;
      
  } else {
    fgets(date,40,fp);
    fclose(fp);
    load_lup_ent(db,longest);
  }

  fp=fopen(longest,"r");
  if(!fp) {
    printf("Run ruplist without parameters once. The longest uptime database will\n");
    printf("then be initialised. Try again with the -l option to see longest uptimes.\n");
    return;
  }
  fclose(fp);   
  printf("All time longest uptimes ever since %s",date);
  if(show_mode==0)
    printf("=======[site name]==========[longest uptime]==================================\n");
  else
    printf("===YE=LW=LM===[site name]===========[longest uptime]==========================\n");
  
  sort_type=0;
  show_lup_ent(*db);
  y=10-strlen(VERSION);
  while(y-->0)
    printf("="); 
  printf("=====================================================[ruplist %s]=====\n",VERSION);  
  if(show_mode==0) {
    printf("<- = Steady       /\\ = Climbed       \\/ = Fallen       -- = New entry\n"); 
  }
  if(show_mode==1) {
    printf("YE - The rankings of yesterday                 LW - The rankings of last week\n");
    printf("LM - The rankings of last month\n");
  }
  
}

int check_longest_uptimes(void)
{
/* Whats to do: read the stamp file and see which files will have to be updated */

  int changes;
  char input[256],stamp[3][40],month1[256],month2[256],rest[256];
  FILE *fp,*yfp,*wfp,*mfp;
  time_t tijd,ytime,wtime,mtime;
  int i;
  
  
  changes=0;			/* Changes tag. Zero if nothing changed */
  fp=fopen(stamps,"r");
  if(!fp) {
    /* It seems that this is the first time ruplist has been run.... */
    
    unlink(stamps);
    fp=fopen(stamps,"w");
    if(!fp) {
      printf("Ruplist: Could not open and write stamp file.\n");
      exit(0);
    }
    tijd=time((time_t *)0);
    fprintf(fp,"%ld\n",tijd);
    fprintf(fp,"%ld\n",tijd);
    fprintf(fp,"%ld\n",tijd);
    fclose(fp);
    chmod(stamps, 0666);
    

    unlink(luplisty);
    yfp=fopen(luplisty,"w");
    if(!yfp) {
      printf("Ruplist: Could not open 'longest uptimes of yesterday'-file.\n");
      exit(0);
    }

    unlink(luplistw);
    wfp=fopen(luplistw,"w");
    if(!wfp) {
      printf("Ruplist: Could not open 'longest uptimes of the last week'-file.\n");
      exit(0);
    }

    unlink(luplistm);
    mfp=fopen(luplistm,"w");
    if(!mfp) {
      printf("Ruplist: Could not open longest uptimes of yesterday file.\n");
      exit(0);
    }

    fp=fopen(longest,"r");
    if(!fp) {
      printf("Ruplist: Could not open longest uptimes file.\n");
      exit(0);
    }
    
    while(!feof(fp)) {
      if(!fgets(input,256,fp))
        break;			/* End of file or error */
      fputs(input,yfp);    
      fputs(input,wfp);    
      fputs(input,mfp);    
    }
    
    fclose(fp);
    fclose(yfp);
    fclose(wfp);
    fclose(mfp);    
    
    /* Setting file privs right */
    chmod(luplisty, 0666);
    chmod(luplistw, 0666);
    chmod(luplistm, 0666);
     
  } else {
/*  vergelijk de data van de stamps file en update een die moet */
    fgets(stamp[0],40,fp); /* yesterday stamp */
    fgets(stamp[1],40,fp); /* week stamp */
    fgets(stamp[2],40,fp); /* month stamp */
    
    tijd=time((time_t *) NULL);
    sscanf(stamp[0],"%39ld",&ytime);
    sscanf(stamp[1],"%39ld",&wtime);
    sscanf(stamp[2],"%39ld",&mtime);
    
    if(tijd-ytime>86400) {
      unlink(luplisty);
      yfp=fopen(luplisty,"w");
      if(!yfp) {
        printf("Ruplist: Could not open 'longest uptimes of yesterday'-file.\n");
        exit(0);
      }  

      fp=fopen(longest,"r");
      if(!fp) {
        printf("Ruplist: Could not open longest uptimes file.\n");
        exit(0);
      }
      
      while(!feof(fp)) {
        if(!fgets(input,256,fp))
          break;			/* End of file or error */
        fputs(input,yfp);    
      }
      fclose(yfp);
      chmod(luplisty, 0666);
      ytime=tijd;
      changes=1;
    }
    
    if(tijd-wtime>604800) {
      unlink(luplistw);
      wfp=fopen(luplistw,"w");
      if(!wfp) {
        printf("Ruplist: Could not open 'longest uptimes of last week'-file.\n");
        exit(0);
      }  

      fp=fopen(longest,"r");
      if(!fp) {
        printf("Ruplist: Could not open longest uptimes file.\n");
        exit(0);
      }
      
      while(!feof(fp)) {
        if(!fgets(input,256,fp))
          break;			/* End of file or error */
        fputs(input,wfp);    
      }
      fclose(wfp);
      chmod(luplistw, 0666);
      wtime=tijd;
      changes=1;
    }
    for (i = 0; i < 256; i++) {
      input[i] = month1[i] = month2[i] = rest[i] = '\0';
    }
    sscanf(ctime(&tijd),"%255s%255s%255s",input,month1,rest);
    sscanf(ctime(&mtime),"%255s%255s%255s",input,month2,rest);
    if(strcmp(month1,month2)) {
      unlink(luplistm);
      mfp=fopen(luplistm,"w");
      if(!mfp) {
        printf("Ruplist: Could not open 'longest uptimes of last month'-file.\n");
        exit(0);
      }  

      fp=fopen(longest,"r");
      if(!fp) {
        printf("Ruplist: Could not open longest uptimes file.\n");
        exit(0);
      }
      
      while(!feof(fp)) {
        if(!fgets(input,256,fp))
          break;			/* End of file or error */
        fputs(input,mfp);    
      }
      fclose(mfp);
      chmod(luplistm, 0666);
      mtime=tijd;
      changes=1;
    }
    if(changes) {
      unlink(stamps);
      fp=fopen(stamps,"w");
      if(!fp) {
        printf("Ruplist: Could not open and write stamp file.\n");
        exit(0);
      }
      fprintf(fp,"%ld\n",ytime);
      fprintf(fp,"%ld\n",wtime);
      fprintf(fp,"%ld\n",mtime);
      fclose(fp);
      chmod(stamps, 0666);
    }
  }

  return 1;
}

void show_help(void) {
   printf("ruplist - version %s written by Roalt Zijlstra\n",VERSION);
   printf("Options: -h --help     gives this text\n");
   printf("         -l            gives the longest uptime list (compact).\n");
   printf("         -t            gives the longest uptime list (total).\n");
   printf("         -v            shows the version number of ruplist.\n");
   printf("         -s            runs ruplist in silent mode (for crontab).\n");
   printf("         -f <filename> make ruplist use a custom filename (for cgi-bins).\n");
}

int main(int argc, char *argv[]) {

  int x,y,dropouts;
  int prev_total_sites;
  char username[40],ruplist[256];
  char input[1024],name[20],rest[256],ruptime[20],*names,*ntmp;
  FILE *fp;
  DIR *dir;
  lup_ent *db;
  
  db=NULL;  
    
/* Some safety things first */

 strncpy(input,RUPLDIR,255);
 strcat(input,"ruplist");

 fp=fopen(input,"r");
 if(!fp) {
   if(mkdir(input, 0777)) {
     printf("Ruplist: Could not create 'ruplist' directory.\n");
     return 0;
   }
   /* set privs right due to umask on mkdir mode */
   if(chmod(input, 0777)) {
     printf("Ruplist: Privileges are not set right.\n");
     return 0;
   }  
 }

/* ============== Some code saving definitions ============== */

 strncpy(longest,input,230);
 strncat(longest,"/longest_uptimes",24); 
 strncpy(luplisty,input,230);
 strncat(luplisty,"/luplist.yesterday",24); 
 strncpy(luplistw,input,230);
 strncat(luplistw,"/luplist.week",24); 
 strncpy(luplistm,input,230);
 strncat(luplistm,"/luplist.month",24);
 strncpy(stamps,input,230);
 strncat(stamps,"/stamps",24);
 
/* ========================================================== */ 


  
/* first parse the arguments if there are any */
  
  sort_type=0;                /* sort option is on uptimes                 */
  sil_mode=0;		      /* 0=verbose                                 */
                              /* 1=silent mode                             */
                              /* 2=silent mode for running longest uptimes */
                              /*   for the first time                      */
                              
  show_mode=0;		      /* Show mode of the longest uptimes          */
  			      /* 0 = default */
  			      /* 1 = show all old rankings */
  custom_home=NULL;	      /* Optionally you can give a custom home dir */

/* First parsing those arguments (in a simple way) */
  for(x = 1; x < argc; x++) {
    if(argv[x][0]=='-') {
      switch(argv[x][1]) {
        case 'h' :
          show_help();
          return 1;
        case 'l' : case 't' :
          if(argv[x][1]=='t')
            show_mode=1;
          longest_uptimes(&db);
          if(sil_mode==2) {
             /* going for silent mode (first time longest uptimes is run */
             break;
          } else {
             /* Otherwise we just quit */ 
             return 1;
          }
        case 'v' :
          printf("Ruplist - version %s written by Roalt Zijlstra\n",VERSION);
          return 1;
        case 's' :
          sil_mode=1;
          break;
        case 'f' :
         if(x+1<argc) {
          dir=opendir(argv[x+1]);
          if(dir!=NULL) {
            closedir(dir); 
            printf("Ruplist: %s is a directory, give a filename please.\n",argv[x+1]);
            exit(0);
          }
               
          custom_home=malloc((strlen(argv[x+1]) + 1) * sizeof(char));
          strcpy(custom_home,argv[x+1]);
          x++;
          break;
         } else {
           printf("Ruplist: Give a filename after the -f switch.\n");
           exit(0);
         } 
        case '-' :
          switch (argv[x][2]) {
            case 'h' :
              show_help();
              return 1;
            default :
              printf("Invalid argument %s. Use ruplist -h for more help on arguments.\n",argv[x]);
              return 1;
          }
        default :
          printf("Invalid argument %s. Use ruplist -h for more help on arguments.\n",argv[x]);
          return 1;
      }
    } else {
      printf("Use ruplist -h for more help on arguments.\n");
      return 1;
    }
      
  } 
 
/* Getting the User name */
  if(getenv("USER"))
    strncpy(username,getenv("USER"),39);
    
/* for some Slackware distributions they have LOGNAME instead of USER */
  if(getenv("LOGNAME"))
    strncpy(username,getenv("LOGNAME"),39);
    

/* Checking for earlier ruplist tmp files */
  if(getenv("HOME")) {
    strncpy(ruplist,getenv("HOME"),230);
    dir=opendir(ruplist);
    if(dir) 
      closedir(dir);
    else {
      printf("Ruplist: Directory %s not found. Exiting!!\n",ruplist);
      return 0;
    }
    strncat(ruplist,"/.ruplist",24);
  } else {
    strcpy(ruplist,"/tmp/ruplist.nobody"); /* for use if run as cgi bin */
  }
    

  if(sil_mode!=0) 
    strcpy(ruplist,"/tmp/ruplist.tmp"); /* Use a tmp file if it's there */
                                        /* for the silent mode          */
  /* Definition of the custom_home char pointer overrides silent mode 
     ruplist dir as set in the above strcpy
  */
  if(custom_home) {
    strncpy(ruplist,custom_home,255);                                       
  }
                                        
  names=NULL;
  prev_total_sites=0;
  fp=fopen(ruplist,"r");
  if(fp) {
    /* Count how many lines there are in the ruplist file */
    while(!feof(fp)) {
      fgets(input,1024,fp);
      if(feof(fp))
        break;
      prev_total_sites++;
    }
    names=malloc((prev_total_sites * 22) * sizeof(char));
    if(!names) {
      printf("Ruplist: Out of memory! Could not allocate work memory.\n");
      exit(0);
    }
    ntmp=names;
    rewind(fp);
    x=0;
    /* Get that ruplist file into memory */
    while(!feof(fp)) {
      fgets(input,1024,fp);
      if(feof(fp))
        break;
      sscanf(input,"%19s%256s",name,rest);  
      strcpy(ntmp,name);
      ntmp=ntmp+20;
    }
    fclose(fp);
  } else {
    names=malloc(20 * sizeof(char));
    if(!names) {
      printf("Ruplist: Out of memory! Could not allocate work memory.\n");
      return 0;
    }
  }
  
  unlink(ruplist); 		/* Again for safety so custum homes cannot be 
  				   missused */
  strncpy(input,RUPTIME,150); 
  strcat(input," -t | grep 'up ' > ");
  strncat(input,ruplist,80);
  system(input);
  fp=fopen(ruplist,"r");   
  if(!fp) {
    printf("ruplist: No space in 'ruplist' directory.\n");
    return 0;
  }

  load_lup_ent(&db,longest);

  
  if(sil_mode==0)  
    printf("==============================================================================\n");
  x=1;
  while(feof(fp)==0) {
    fgets(input,1024,fp);
    if(feof(fp)) 
      break;
    if(strlen(input)<1 || strlen(input)>1023) {
      printf("Debug info: ruptime info was invalid.\n");
      break;
    }
    sscanf(input,"%19s%255s%19s",name,rest,ruptime);  
    if(ruptime) {
      if(ruptime[0]=='?') {   /* Apperently there is a bug in ruptime */
        break;               /* This is a dirty fix. Will do better when ruptime is */
                             /* merged into ruptime... Making it independ to run */
      }
      
    }
    update_longest_uptime(&db,name,ruptime);
    y=1;
    ntmp=names;
    while(y<=prev_total_sites) {
      if(!strcmp(ntmp,name)) {
        break;
      }
      y++;
      ntmp=ntmp+20;
    }
    if(sil_mode==0) {
      printf("%2d ",x++);
      if(!strcmp(ntmp,name))
        printf("%2d - %s",y,input);
      else 
        printf("-- - %s",input);
    } else
      x++;
      if(ntmp)
      *ntmp='\0';
  }
  if(fp)
    fclose(fp);
  if(x==1) {
    printf("Ruplist: Ruplist did not get the expected information from other applications.\nThis information is vital to run ruplist properly.\n");
  }
  if(sil_mode==0) {
    y=10-strlen(VERSION);
    while(y-->0)
      printf("="); 
    printf("=====================================================[ruplist %s]=====\n",VERSION);  
  }
  x--;

  if(sil_mode==0) {

/* now figure out the drop outs */
  y=1;
  dropouts=0;
  ntmp=names;
  while(y<=prev_total_sites) {
    if(*ntmp!='\0')
      dropouts++;
    y++;
    ntmp=ntmp+20;
  }
  
  if(dropouts) {
    if(dropouts==1)
      printf("%d site dropped out: ",dropouts);
    else
      printf("%d sites dropped out: ",dropouts);
    y=1;
    ntmp=names;
    while(y<=prev_total_sites) {
      if(*ntmp!='\0')
        printf("%s ",ntmp);
      y++;
      ntmp=ntmp+20;
    }
    printf("\n");
  }    
                                          
  if((x-(prev_total_sites-dropouts))==1)
    strcpy(input,"site");
  else
    strcpy(input,"sites");  

  if((prev_total_sites-dropouts)!=x) 
    printf("%d %s went online.\n",x-(prev_total_sites-dropouts),input);
 
  } /* endif of silent mode check */

  if(names)
    free(names);

  save_lup_ent(db,longest);

/* See if the backup longest uptime files are enogh up to date */
  check_longest_uptimes();  

  clean_lup_ent(&db);

  db=NULL;
  if(sil_mode==2) /* show those longest uptimes the first time */
     longest_uptimes(&db);
 
  if(strcmp(ruplist,"/tmp/ruplist.tmp")==0) 
    remove("/tmp/ruplist.tmp");
 
  return 1;
}
